package aLibrary;
import java.io.Serializable;
	
	/*	class invariant
			A Bag object ...
				* is a container of zero or more other objects
				* is capable of storing anything that conforms to Object */
public class Bag extends SimpleList implements Serializable  {
	/*	postcondition
			this is an empty bag (i.e. count() == 0) */
	public Bag()  {
		super();
	} 
	
	/*	postcondition
			result == number of items in this Bag
		note: this method is inherited 
	public int count()   */
	
	/*	postcondition
			this == old this with x inserted
		note: this method is inherited 
	public void insert( Object x )   */

	/*	precondition
			count() > 0
		postcondition
			this == old this with some item removed
			AND  count == old count -1
		note: this method is inherited 
	public void remove()   */

	/*	precondition
			count() > 0
		postcondition
			result == one of the items from this */
	public Object item()   {
		int skipCount;
		super.start();
		// the following code randomizes which item is returned.
		skipCount = (int) (Math.random() * count());
		for ( ; skipCount>0; skipCount--)   {
			super.forth();
		}
		return super.item();
	}

	public String toString()  {
		String str = "";
		super.start();
		while (!super.isOff())   {
			str = str + super.item().toString();
			super.forth();
		}
		return str;
	} 


// The methods below are overridden to disable them.
	/*	postcondition
			this method is disabled */
	public void start() {
	} 

	/*	postcondition
			this method is disabled */
	public void forth()  {
	}  
}